.test-defaults-write: &test-defaults-write
  - |
    echo -e "\e[0Ksection_start:`date +%s`:test-defaults[collapsed=true]\r\e[0KWrite defaults for tests"
    echo '' > ./test-report.out
    echo '' > ./test-report.junit.xml
    echo '' > ./test-coverage.out
    echo '' > ./test-coverage.cobertura.xml
    echo -e "\e[0Ksection_end:`date +%s`:test-defaults\r\e[0K"

.rewrite-report-paths: &rewrite-report-paths
  - |
    echo -e "\e[0Ksection_start:`date +%s`:test-report-rewrites[collapsed=true]\r\e[0KRewrite directories in test report"
    sed -i "s|/app/|$CI_PROJECT_DIR/|" $CI_PROJECT_DIR/test-report.out
    sed -i "s|/app/|$CI_PROJECT_DIR/|" $CI_PROJECT_DIR/test-report.junit.xml
    sed -i "s|/app/|$CI_PROJECT_DIR/|" $CI_PROJECT_DIR/test-coverage.out
    sed -i "s|/app/|$CI_PROJECT_DIR/|" $CI_PROJECT_DIR/test-coverage.cobertura.xml
    echo -e "\e[0Ksection_end:`date +%s`:test-report-rewrites\r\e[0K"

.laravel-defaults-init: &laravel-defaults-init
  - |
    cd /app/
    cp .env.example .env
    php artisan key:generate --ansi

.test-suite.laravel:
  extends: .test-suite
  variables:
    GIT_STRATEGY: none
    MAIL_MAILER: log
    XDEBUG_MODE: coverage
  before_script:
    - |
      cat << EOF 
      $WELCOME_TEST_MESSAGE
      ‎ ‎ ‎
      $UNSERVICED_TEST_MESSAGE
      EOF
    - *test-defaults-write
    - *laravel-defaults-init
  after_script:
    - *rewrite-report-paths

.test-suite.laravel.serviced:
  extends: .test-suite.serviced
  variables:
    GIT_STRATEGY: none

    SCOUT_DRIVER: meilisearch
    MEILISEARCH_HOST: http://meilisearch:7700
    MEILISEARCH_KEY: meilisearch

    REDIS_HOST: redis
    REDIS_PASSWORD: redis
    REDIS_PORT: 6379

    MAIL_MAILER: log
    XDEBUG_MODE: coverage
  before_script:
    - |
      cat << EOF 
      $WELCOME_TEST_MESSAGE
      ‎ ‎ ‎
      $SERVICED_TEST_MESSAGE
      EOF
    - *test-defaults-write
    - *laravel-defaults-init
  after_script:
    - *rewrite-report-paths